/* gamemain2.c */
#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<stdlib.h>
#include<enemy.h>
#include<movingobjectmanager.h>
#ifdef DEBUG
#include<log.h>
#endif

#define OBJNUM 2
#define MOBJNUM 3
#define EVNUM 101

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];
movingobject* mobjp1[MOBJNUM];
movingobject* mobjp2[MOBJNUM];
movingobject* mobjp3[MOBJNUM];
movingobject* mobjp4[MOBJNUM];
movingobject* mobjp5[MOBJNUM];
event* ev[EVNUM];
vector2 mypos;
int isfire;
int score,result; 

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

int bomba(movingobject* mobj){
  score+=88;
  return 1;
}

void initobjects(void){
  objp[0] = newobject(1,1,"x");
  objp[1] = newobject(3,2," ^ =x=");
}

void initmovingobjects(void){
  mobjp[0] = newenemy();
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp1[0] = newenemy_chitose1();
  mobjp1[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp1[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp2[0] =  newenemy_chitose2();
  mobjp2[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp2[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp3[0] =  newenemy_tsuchida();
  mobjp3[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp3[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp4[0] =  maynewenemy();
  mobjp4[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp4[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
  mobjp5[0] =  maynewenemy2();
  mobjp5[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp5[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
}

void setevents(void){
  int i,j;

  srand((unsigned)time(NULL));
  for(i=0;i<100;i+=5){
    j=rand();
    ev[i] = newevent((8*i)+8, makevector2(j%35,j%6),makevector2(0.1,0.1), mobjp[0],"plus0");
  }
  for(i=1;i<100;i+=5){
    j=rand();
    ev[i] = newevent((8*i)+8, makevector2(j%35,j%6),makevector2(-0.1,0.2), mobjp1[0],"plus1");
  }
  for(i=2;i<100;i+=5){
    j=rand();
    ev[i] = newevent((8*i)+8, makevector2(j%35,j%6),makevector2(-0.2,0.1), mobjp2[0],"plus2");
  }
  for(i=3;i<100;i+=5){
    j=rand();
    ev[i] = newevent((8*i)+8, makevector2(j%35,j%6),makevector2(0.2,0.2), mobjp3[0],"plus3");
  }
  for(i=4;i<100;i+=5){
    j=rand();
    ev[i] = newevent((8*i)+8, makevector2(j%35,j%6),makevector2(0.2,0.1), mobjp4[0],"plus3");
    ev[i+1] = newevent((8*i)+9, makevector2(j%35,j%6+4),makevector2(0.2,0.3), mobjp5[0],"plus3");
  }
  ev[100] = newevent(1000000,makevector2(30,1),makevector2(0,1), mobjp[0],"dummy");

  for(i=0;i<EVNUM;i++){
    addevent(ev[i]);
  }
  resetmark();
}

void init(void){
  initscreen();
  initwalls();
  initmom();
  initobjects();
  initmovingobjects();
  initscenario();
  setevents();
}


void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int in = gameioread();
  switch(in){
  case 'k':
  case 'K':
    pos.x++;
    break;
  case 'd':
  case 'D':
    pos.x--;
    break;
  case 'j':
  case 'J':
    pos.y--;
    break;
  case 'f':
  case 'F':
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
  } 
  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){
  int speedlevel = 8;
  int n=0;
  int time=0;
  vector2 tmpv;
  event* e = getnextevent();
  while(1){
    gameiousleep(30000);
    if(time%speedlevel == 0){
      scrollwall();
      n++;
      while(e!= NULL && e->time*speedlevel < time){
        addmo(e->mobj, e->pos, e->vel);
        e = getnextevent();
      }
      score++;
    }
    if(time%700==0&&speedlevel>1){
      speedlevel--;
    }
    getstate(&mypos, &isfire);
    gameioput(SCREENWIDTH+3,1,'0'+(int)mypos.x/10);
    gameioput(SCREENWIDTH+4,1,'0'+(int)mypos.x%10);
    gameioput(SCREENWIDTH+6,1,'0'+(int)mypos.y/10);
    gameioput(SCREENWIDTH+7,1,'0'+(int)mypos.y%10);
    gameioput(SCREENWIDTH+3,38,'s');
    gameioput(SCREENWIDTH+4,38,'c');
    gameioput(SCREENWIDTH+5,38,'o');
    gameioput(SCREENWIDTH+6,38,'r');
    gameioput(SCREENWIDTH+7,38,'e');
    gameioput(SCREENWIDTH+10,38,'0'+(int)(score%1000)/100);
    gameioput(SCREENWIDTH+11,38,'0'+(int)((score%1000)%100)/10);
    gameioput(SCREENWIDTH+12,38,'0'+(int)score%1000%100%10);
    gameioput(SCREENWIDTH+3,2,'L');
    gameioput(SCREENWIDTH+4,2,'e');
    gameioput(SCREENWIDTH+5,2,'v');
    gameioput(SCREENWIDTH+6,2,'e');
    gameioput(SCREENWIDTH+7,2,'l');
    gameioput(SCREENWIDTH+9,2,'8'-(int)speedlevel);
    if(score>=1000){
      gameioput(SCREENWIDTH+9,38,'0'+(int)score/1000);
    }
    putwalls(SCREENHEIGHT);
    putmo();
    onestepmo();
    if(checkcollision(mypos, objp[1])!=NONOBJ){
      result=1;
      break;
    }
    if(n>=560){
      result=2;
      break;
    }

    if(isfire){
      tmpv = mypos;
      tmpv.x +=1;
      tmpv.y -=2;
      addmo(mobjp[1], tmpv, makevector2(0,-1));
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
    show();
    time++;
  }
}

int main(void){
  printf("奇妙な世界に入り込んでしまったようだ。\n壁に囲まれた空間、そして障害物。\nさらには奇妙な動きをした得体の知れない生物。\n世界をすくうためには我々がシューティングスターとなってこいつらを狙撃しなければならない。\nさぁ、君はこの世界の救世主となることができるのか！\n\n〜操作説明〜\n壁や障害物を避けながら'スペースキー'を押して敵を撃ち落とせ！\n'k'で右に移動、'd'で左に移動、'j'で上に移動、'f'で下に移動できるぞ！\n※ターミナルを全画面表示にするとこの世界の様子がわかりやすいようだ。\n用意ができたら'returnキー'を押してスタート☆\n");
  while(getchar()!='\n');
  gameioinit();
  gameioclear();
  init();
  
  score=0;
  gameloop();

  gameiopost();
  if(result==1){
    printf("／/Game Over\\＼\n周りをよく見ないと痛い目にあうZe☆\n");
  }
  else if(result==2){
    printf("＼\\Game Clear/／\nありがとう！あなたのおかげで世界は救われました！\n");
  }
  printf("score:%d\n",score);
  if(score<250){
    printf("むずかしかったかなぁ〜？m9(^Д^)9mぷぎゃー!!\n");
  }
  else if(score<700&&score>250){
    printf("まぁまぁの出来だね( ´,_ゝ｀)\n");
  }
  else if(score<1060&&score>=500){
    printf("けっこういい出来じゃん(・ε・)\n");
  }
  else if(score<2000&&score>=1060){
    printf("なんか…お前すげぇな…( °Д°)\n");
  }
  else if(score>=2000){
    printf("参りましたm(_ _)m\n");
  }
  return 0;
}
